/**
 * Copyright (c) 2004-2014 Gabor Bergmann and Daniel Varro
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-v20.html.
 * 
 * SPDX-License-Identifier: EPL-2.0
 */
package org.eclipse.viatra.query.runtime.rete.recipes;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Eval Recipe</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Computes the result of expression evaluation and suffixes the result
 * to output tuples as the last element.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.viatra.query.runtime.rete.recipes.EvalRecipe#isUnwinding <em>Unwinding</em>}</li>
 * </ul>
 *
 * @see org.eclipse.viatra.query.runtime.rete.recipes.RecipesPackage#getEvalRecipe()
 * @model
 * @generated
 */
public interface EvalRecipe extends ExpressionEnforcerRecipe {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String copyright = "Copyright (c) 2004-2014 Gabor Bergmann and Daniel Varro\nThis program and the accompanying materials are made available under the\nterms of the Eclipse Public License v. 2.0 which is available at\nhttp://www.eclipse.org/legal/epl-v20.html.\n\nSPDX-License-Identifier: EPL-2.0"; //$NON-NLS-1$

	/**
	 * Returns the value of the '<em><b>Unwinding</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * @since 2.4
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Unwinding</em>' attribute.
	 * @see #setUnwinding(boolean)
	 * @see org.eclipse.viatra.query.runtime.rete.recipes.RecipesPackage#getEvalRecipe_Unwinding()
	 * @model
	 * @generated
	 */
	boolean isUnwinding();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra.query.runtime.rete.recipes.EvalRecipe#isUnwinding <em>Unwinding</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Unwinding</em>' attribute.
	 * @see #isUnwinding()
	 * @since 2.4
	 * @generated
	 */
	void setUnwinding(boolean value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model kind="operation" unique="false"
	 * @generated
	 */
	int getArity();

} // EvalRecipe
